#include <stdio.h>
#include <iostream>
#include <fstream> 

using namespace std;

// An unsigned char can store 1 Bytes (8bits) of data (0-255)
typedef unsigned char BYTE;

// Get the size of a file
long getFileSize(FILE *file)
{
	long lCurPos, lEndPos;
	lCurPos = ftell(file);
	fseek(file, 0, 2);
	lEndPos = ftell(file);
	fseek(file, lCurPos, 0);
	return lEndPos;
}

//----------------GSUMMARY----------------------------------------------

int gsummary()
{
		
	const char *filePath = "GSUMMARY.DB";	
	BYTE *fileBuf;			// Pointer to our buffered data
	FILE *file = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file = fopen(filePath, "rb")) == NULL)
		cout << "Could not open GSUMMARY.DB" << endl;
	else
		cout << "GSUMMARY.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize = getFileSize(file);
	
	int lastbyte = fileSize -1;

	// Allocate space in the buffer for the whole file
	fileBuf = new BYTE[fileSize];

	// Read the file in to the buffer
	fread(fileBuf, fileSize, 1, file);
   // Whole file buffered
   
   // ANOTHER FILE------------
   const char *filePath2 = "KEY.DB";	
	BYTE *fileBuf2;			// Pointer to our buffered data
	FILE *file2 = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file2 = fopen(filePath2, "rb")) == NULL)
		cout << "Could not open KEY.DB" << endl;
	else
		cout << "KEY.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize2 = getFileSize(file2);
	
	int lastbyte2 = fileSize2 -1;

	// Allocate space in the buffer for the whole file
	fileBuf2 = new BYTE[fileSize2];

	// Read the file in to the buffer
	fread(fileBuf2, fileSize2, 1, file2);

	// Whole file buffered

        fclose(file2);   // Closing file 
	
    //ANOTHER FILE-----
	const char *filePath3 = "TEAMS.DB";	
	BYTE *fileBuf3;			// Pointer to our buffered data
	FILE *file3 = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file3 = fopen(filePath3, "rb")) == NULL)
		cout << "Could not open specified TEAMS.DB" << endl;
	else
		cout << "TEAMS.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize3 = getFileSize(file3);
	
	int lastbyte3 = fileSize3 -1;

	// Allocate space in the buffer for the whole file
	fileBuf3 = new BYTE[fileSize3];

	// Read the file in to the buffer
	fread(fileBuf3, fileSize3, 1, file3);

	// Whole file buffered
		
        fclose(file3);   // Closing file 
	//--------------------
	
	
	
	// Teams to boxscore
    
    int hometeam;
    string homet;
    hometeam = fileBuf[3];
    homet = "";
    
    for( int a=0; a < 3; a = a+1 ) // get 3 team chars from TEAMS.DB
                       {
                            homet += fileBuf3[a + (hometeam * 744)];     
                       }
        
    int visitorteam;
    string visit;
    visitorteam = fileBuf[4];
    visit = "";
    
    for( int a=0; a < 3; a = a+1 )
                       {
                            visit += fileBuf3[a + (visitorteam * 744)];     
                       }
    
    
    // Opening file for writing boxscore   
    ofstream myfile;
    myfile.open ("gamesummarystats.txt");
    // Teams
    myfile << (homet) << ":" << (visit);
    
    // Summary
    int value; //Current value in GSUMMARY
    int cursor; //Current place in GSUMMARY
    cursor = 11; //Starting place on 1st block on 1st row
    string code;
    int team;
    value = fileBuf[11];
    int period = 0;
    int alkupiste; //TEAMS.DB team first offset (+744*teams) + 76 = first player offset
    int matkapelaajaan;
    int alku;
    string etunimi;
    string sukunimi;
    int homeshotstotal = 0;
    int vshotstotal = 0;
    
    while ( cursor < lastbyte ) {  // Start of While loop
    
    switch ( value ) 
        {
             // GOALS AND ASSISTS
             case 1:   // Goal       
                 code ="Goal";
                 myfile << "\n" << (code);
                 cursor = cursor + 1;
                 value = fileBuf[cursor];
                 switch ( value )  //Home or Visitor goal
                        {
                            case 0:            
                                myfile << ":" << (homet) << ":" ;
                                team = (fileBuf[3]);
                                break;
                            case 1:          
                                myfile << ":" << (visit) << ":" ;
                                team = (fileBuf[4]);
                                break;
                            default:            
                                printf( "Bad input for home or visitor team!\n" );
                                break;
                        }
                cursor = cursor + 1;
                value = fileBuf[cursor]; // Goal scorer
                
                // Find player name
                alkupiste = 76;
                matkapelaajaan = value * 4;
                alkupiste = alkupiste + (team * 744) + matkapelaajaan;
                alku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offset to KEY.DB
                etunimi = ""; // wiping out variables so old names do not come here
                sukunimi = "";
                
                int gplayer;
                
                gplayer = alku + 3;
                 // get all cahrs for firstname and put those in varialbe:etunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[gplayer+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[gplayer+a];     
                       }
                
                gplayer = alku + 19;
                 // get all cahrs for lastname and put those in varialbe:sukunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[gplayer+a] != 0; a = a+1 )
                       {
                            sukunimi += fileBuf2[gplayer+a];     
                       }
                
                myfile << (etunimi) << " " << (sukunimi) << ":";
               // Finding names ends here
                
                cursor = cursor + 1;
                value = fileBuf[cursor]; // 1 assist
                
                
                //------------- IF   ------------
                if (value != 255) // there is no fist assists? 
                {
                // finding name starts here
                alkupiste = 76;
                matkapelaajaan = value * 4;
                alkupiste = alkupiste + (team * 744) + matkapelaajaan;
                alku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offset to KEY.DB
                etunimi = ""; // zeroing variables
                sukunimi = "";
                
                int a1player;
                
                a1player = alku + 3;
                 /// get all cahrs for firstname and put those in varialbe:etunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[a1player+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[a1player+a];     
                       }
                
                a1player = alku + 19;
                 // get all cahrs for lastname and put those in varialbe:sukunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[a1player+a] != 0; a = a+1 )
                       {
                            sukunimi += fileBuf2[a1player+a];     
                       }
                
                myfile << (etunimi) << " " << (sukunimi) << ":";
               // finding names ends here
               
               cursor = cursor + 1;
               value = fileBuf[cursor]; // 2 assist
                         if (value != 255) // no second assist?
                    {
                    // Find name
                    alkupiste = 76;
                    matkapelaajaan = value * 4;
                    alkupiste = alkupiste + (team * 744) + matkapelaajaan;
                    alku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offsetti KEY.DB:hen
                    etunimi = ""; // zeroing variables
                    sukunimi = "";
                    
                    int a2player;
                    
                    a2player = alku + 3;
                     /// get all cahrs for firstname and put those in varialbe:etunimi
                              // stop finding when come to zero
                           for( int a=0; fileBuf2[a2player+a] != 0; a = a+1 )
                           {
                                etunimi += fileBuf2[a2player+a];     
                           }
                    
                    a2player = alku + 19;
                     /// get all cahrs for lastname and put those in varialbe:sukunimi
                              // stop finding when come to zero
                           for( int a=0; fileBuf2[a2player+a] != 0; a = a+1 )
                           {
                                sukunimi += fileBuf2[a2player+a];     
                           }
                    
                    myfile << (etunimi) << " " << (sukunimi) << ":";
                   // Finding names ends here
                   
                   cursor = cursor + 1;
                   value = fileBuf[cursor]; // normal/PP/SH Goal
                   
                   }
                   else {    // no second assist
                        myfile << "NA:";
                        cursor = cursor + 1;
                        value = fileBuf[cursor]; // normal/PP/SH Goal
                         }
               }
               
               else {    // no assists
                        myfile << "NA:" << "NA:";
                        cursor = cursor + 2;
                        value = fileBuf[cursor]; // normal/PP/SH Goal
                        } 
               //--------------------- IF ends ------------------
               
               switch ( value )  //normal/PP/SH Goal
                        {
                            case 1:            
                                myfile << "ES:" ;
                                break;
                            case 2:          
                                myfile << "SH:";
                                break;
                            case 4:          
                                myfile << "PP:";
                                break;
                            case 9:          
                                myfile << "EN:";
                                break;
                            case 10:          
                                myfile << "SE:";
                                break;
                            case 12:          
                                myfile << "PE:";
                                break;
                            default:            
                                printf( "Bad input for N/YV/AV\n" );
                                break;
                        }
                cursor = cursor + 1; // Period
                value = fileBuf[cursor]; 
                myfile << (value) << ":" ;
                
                cursor = cursor + 1; // Scoring time minutes
                value = fileBuf[cursor]; 
                myfile << (value) << ":" ;
                cursor = cursor + 1; // Scoring time seconds
                value = fileBuf[cursor]; 
                if (value < 10) // numbers 0-9 do not print zero in front
                {
                          myfile << "0" << (value);
                }
                else myfile << (value);
                cursor = cursor + 3; // Cursor to 1st place on next row
                value = fileBuf[cursor]; 
              
             break;
             
             // PENALTIES //
             case 2:  // Penalty        
                code ="Penalty";
                myfile << "\n" << (code);
                cursor = cursor + 1;
                value = fileBuf[cursor];
                       switch ( value )  //Home or Visitor penalty
                        {
                            case 0:            
                                myfile << ":" << (homet) << ":" ;
                                team = (fileBuf[3]);
                                break;
                            case 1:          
                                myfile << ":" << (visit) << ":" ;
                                team = (fileBuf[4]);
                                break;
                            default:            
                                printf( "Bad input for home or visitor team!\n" );
                                break;
                        }
                
                cursor = cursor + 1;
                value = fileBuf[cursor]; // Player
                
                // Find names
                alkupiste = 76;
                matkapelaajaan = value * 4;
                alkupiste = alkupiste + (team * 744) + matkapelaajaan;
                alku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offset to KEY.DB
                etunimi = ""; // zeroing variables
                sukunimi = "";
                
                int pplayer;
                
                pplayer = alku + 3;
                 /// get all cahrs for firstname and put those in varialbe:etunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[pplayer+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[pplayer+a];     
                       }
                
                pplayer = alku + 19;
                 /// get all cahrs for lastname and put those in varialbe:sukunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[pplayer+a] != 0; a = a+1 )
                       {
                            sukunimi += fileBuf2[pplayer+a];     
                       }
                
                myfile << (etunimi) << " " << (sukunimi) << ":";
               // Find names ends here
               
                cursor = cursor + 1; // Pen. Reason (options just listed below, not getting it from files)
                value = fileBuf[cursor]; 
                switch ( value ) 
                        {
                            case 0:           
                                 myfile << "Roughing:";
                                 break;
                            case 2:          
                                 myfile << "Charching:";
                                break;
                            case 3:         
                                myfile << "Slashing:";
                                break;
                            case 4:        
                                myfile << "Roughing:";
                                break;
                            case 5:           
                                 myfile << "Crosscheking:";
                                 break;
                            case 6:          
                                 myfile << "Hooking:";
                                break;
                            case 7:         
                                myfile << "Tripping:";
                                break;
                            case 8:        
                                myfile << "Interference:";
                                break;
                             case 9:          
                                 myfile << "Holding:";
                                break;
                            case 10:         
                                myfile << "Highsticking:";
                                break;
                            case 11:        
                                myfile << "Boarding:";
                                break;
                            case 12:           
                                 myfile << "Elbowing:";
                                 break;
                            case 13:          
                                 myfile << "Abuse of offical:";
                                break;
                            case 14:         
                                myfile << "Checking from behind:";
                                break;
                            case 15:        
                                myfile << "Boarding:";
                                break; 
                            case 16:         
                                myfile << "Elbowing:";
                                break;
                            case 17:        
                                myfile << "Penalty shot:";
                                break;      
                            default:            
                                printf( "Bad input in penalty reason!\n" );
                                break;
                        }
                        
                cursor = cursor + 1; // Penalty minutes
                value = fileBuf[cursor]; 
                myfile << (value) << ":";
                cursor = cursor + 1; // Period
                value = fileBuf[cursor]; 
                myfile << (value) << ":";
                
                cursor = cursor + 1; // Penalty time minutes
                value = fileBuf[cursor]; 
                myfile << (value) << ":";
                cursor = cursor + 1; // Penalty time seconds
                value = fileBuf[cursor]; 
                if (value < 10) // numbers 0-9 do not print zero in front
                {
                          myfile << "0" << (value);
                }
                else myfile << (value);
                cursor = cursor + 4; // Cursor to 1st place on next row
                value = fileBuf[cursor]; 
                break;
            
            // INJURIES
            case 3:  // Injury      
                code ="Injury";
                myfile << "\n" << (code);
                cursor = cursor + 1;
                value = fileBuf[cursor];
                       switch ( value )  //Home or Visitor injury
                        {
                            case 0:            
                                myfile << ":" << (homet) << ":" ;
                                team = (fileBuf[3]);
                                break;
                            case 1:          
                                myfile << ":" << (visit) << ":" ;
                                team = (fileBuf[4]);
                                break;
                            default:            
                                printf( "Bad input for home or visitor injury!\n" );
                                break;
                        }
                
                cursor = cursor + 1;
                value = fileBuf[cursor]; // Player
                
                // Find names
                alkupiste = 76;
                matkapelaajaan = value * 4;
                alkupiste = alkupiste + (team * 744) + matkapelaajaan;
                alku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offset to KEY.DB
                etunimi = ""; // zeroing variables
                sukunimi = "";
                
                int iplayer;
                
                iplayer = alku + 3;
                /// get all cahrs for firstname and put those in varialbe:etunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[iplayer+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[iplayer+a];     
                       }
                
                iplayer = alku + 19;
                /// get all cahrs for lastname and put those in varialbe:sukunimi
                              // stop finding when come to zero
                       for( int a=0; fileBuf2[iplayer+a] != 0; a = a+1 )
                       {
                            sukunimi += fileBuf2[iplayer+a];     
                       }
                
                myfile << (etunimi) << " " << (sukunimi) << ":" ;
               // Finding names ends here
               
               cursor = cursor + 1;
               value = fileBuf[cursor]; // Type of injury
               switch ( value )  //GFP/GFG
                        {
                            case 255:            
                                myfile << "GFP:" ;
                                break;
                            case 1:          
                                myfile << "GFG:";
                                break;
                            default:            
                                printf( "Bad input for N/YV/AV\n" );
                                break;
                        }
                cursor = cursor + 1; // Period
                value = fileBuf[cursor]; 
                myfile << (value) << ":";
                
                cursor = cursor + 1; // Injury time minutes
                value = fileBuf[cursor]; 
                myfile << (value) << ":";
                cursor = cursor + 1; // Injury time seconds
                value = fileBuf[cursor]; 
                if (value < 10) // numbers 0-9 do not print zero in front
                {
                          myfile << "0" << (value);
                }
                else myfile << (value);
                cursor = cursor + 5; // Cursor to 1st place on next row
                value = fileBuf[cursor]; 
               
                break;
            
            // SHOTS ON PERIOD
            case 4: /* Shots 
                */
              
                period = period + 1;    
                cursor = cursor + 2; 
                value = fileBuf[cursor]; 
                cursor = cursor + 2; 
                value = fileBuf[cursor]; 
                cursor = cursor + 7;
                value = fileBuf[cursor]; 
                break;
            default:            
                printf( "Bad input!\n" );
                break;
        }
    
        } //End of While loop
    
    
    
    // Closing file
    myfile.close();
    


	//cin.get();
	delete[]fileBuf;     //Deleting Buffer
	delete[]fileBuf2;
	delete[]fileBuf3;
    
    fclose(file);   // Closing file 
    fclose(file2);
    fclose(file3);
   return 0;
}


//------------------GSUMMARY ENDS HERE--------------------------------


int main()
{
	
	const char *filePath = "GAME.SAV";	
	BYTE *fileBuf;			// Pointer to our buffered data
	FILE *file = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file = fopen(filePath, "rb")) == NULL)
		cout << "Could not open GAME.SAV" << endl;
	else
		cout << "GAME.SAV opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize = getFileSize(file);
	
	int lastbyte = fileSize -1;

	// Allocate space in the buffer for the whole file
	fileBuf = new BYTE[fileSize];

	// Read the file in to the buffer
	fread(fileBuf, fileSize, 1, file);
   // Whole file buffered
    
    // ANOTHER FILE------------
   const char *filePath2 = "KEY.DB";	
	BYTE *fileBuf2;			// Pointer to our buffered data
	FILE *file2 = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file2 = fopen(filePath2, "rb")) == NULL)
		cout << "Could not open specified file2" << endl;
	else
		cout << "KEY.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize2 = getFileSize(file2);
	
	int lastbyte2 = fileSize2 -1;

	// Allocate space in the buffer for the whole file
	fileBuf2 = new BYTE[fileSize2];

	// Read the file in to the buffer
	fread(fileBuf2, fileSize2, 1, file2);

	// Whole file buffered
    
     //ANOTHER FILE-----
	const char *filePath3 = "TEAMS.DB";	
	BYTE *fileBuf3;			// Pointer to our buffered data
	FILE *file3 = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file3 = fopen(filePath3, "rb")) == NULL)
		cout << "Could not open TEAMS.DB" << endl;
	else
		cout << "TEAMS.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize3 = getFileSize(file3);
	
	int lastbyte3 = fileSize3 -1;

	// Allocate space in the buffer for the whole file
	fileBuf3 = new BYTE[fileSize3];

	// Read the file in to the buffer
	fread(fileBuf3, fileSize3, 1, file3);

	// Whole file buffered
    
    //ANOTHER FILE-----		
    
	//--------------------
  const char *filePath4 = "GSUMMARY.DB";	
	BYTE *fileBuf4;			// Pointer to our buffered data
	FILE *file4 = NULL;		// File pointer

	// Open the file in binary mode using the "rb" format string
	// This also checks if the file exists and/or can be opened for reading correctly
	if ((file4 = fopen(filePath4, "rb")) == NULL)
		cout << "Could not open GSUMMARY.DB" << endl;
	else
		cout << "GSUMMARY.DB opened successfully" << endl;

	// Get the size of the file in bytes
	long fileSize4 = getFileSize(file4);
	
	int lastbyte4 = fileSize4 -1;

	// Allocate space in the buffer for the whole file
	fileBuf4 = new BYTE[fileSize4];

	// Read the file in to the buffer
	fread(fileBuf4, fileSize4, 1, file4);
   // Whole file buffered
  
  int hometeam;
    string homet;
    hometeam = fileBuf4[3]; //Hometeam from GSUMMARY
    homet = "";
    
    for( int a=0; a < 3; a = a+1 ) // getting team 3 chars from TEAMS.DB
                       {
                            homet += fileBuf3[a + (hometeam * 744)];     
                       }
        
    int visitorteam;
    string visit;
    visitorteam = fileBuf4[4]; //Visitorteam from GSUMMARY
    visit = "";
    
    for( int a=0; a < 3; a = a+1 ) // getting team 3 chars from TEAMS.DB
                       {
                            visit += fileBuf3[a + (visitorteam * 744)];     
                       }
  // Opening file for writing   
   
   ofstream myfile;
   
   myfile.open ("gamestats.txt");
    
   string gameid = "";
   cout << "Enter gameid: ";
   cin >> gameid;
   string season = "KOHL1"; //Season name, can be changed to be asked each time, otherwise change it here.
   string round = "";
   cout << "Enter round: ";
   cin >> round;

  myfile << (gameid) << ":" << (season) << ":" << (round) << "\n";
  myfile << (homet) << ":" << (visit) << "\n";
  
 
  int value; //Current value in GAME.SAV
    int cursor; //Current place in GAME.SAV
    cursor = 0; //Starting place on 1st block on 1st row
    
    int homeshots = fileBuf[1794];
    int visitorshots = fileBuf[2006];
    int homePPGoals = fileBuf[1796];
    int visitorPPgoals = fileBuf[2008];
    int homePPtimes = fileBuf[1798];
    int visitorPPtimes = fileBuf[2010];
    int homePPshots = fileBuf[1800];
    int visitorPPshots = fileBuf[2012];
    int homePPtime = fileBuf[1802];
    int visitorPPtime = fileBuf[2014];
    int homePPtimemulti = fileBuf[1803]; // 01=256sec
    int visitorPPtimemulti = fileBuf[2015];
    int homeSHtimes = fileBuf[1804];  // Game calculates this wrong?
    int visitorSHtimes = fileBuf[2016]; // Game calculates this wrong?
    int homePenminutes = fileBuf[1806];
    int visitorPenminutes = fileBuf[2018];
    int homeAzonetime = fileBuf[1808];
    int visitorAzonetime = fileBuf[2020];
    int homeAzonetimemulti = fileBuf[1809]; // 01=256sec
    int visitorAzonetimemulti = fileBuf[2021];
    int homeGoals = fileBuf[1810];
    int visitorGoals = fileBuf[2022];
    int homeFaceoffswon = fileBuf[1812];
    int visitorFaceoffswon = fileBuf[2024];
    int homeOffFaceoffswon = fileBuf[1814];
    int visitorOffFaceoffswon = fileBuf[2026];
    int homeOnetimerpass = fileBuf[1816];
    int visitorOnetimerpass = fileBuf[2028];
    int homeOnetimershot = fileBuf[1818];
    int visitorOnetimershot = fileBuf[2030];
    int homeBodychecks = fileBuf[1830];
    int visitorBodychecks = fileBuf[2042];
    int homePassingattempt = fileBuf[1832];
    int visitorPassingattempt = fileBuf[2044];
    int homePassingattemptmulti = fileBuf[1833];
    int visitorPassingattemptmulti = fileBuf[2045];
    int homePassingsuccess = fileBuf[1834];
    int visitorPassingsuccess = fileBuf[2046];
    int homePassingsuccessmulti = fileBuf[1835];
    int visitorPassingsuccessmulti = fileBuf[2047];
    
    myfile << (homeGoals) << ":" << (visitorGoals) << "\n";
    myfile << (homeshots) << ":" << (visitorshots) << "\n";
    myfile << (homePPGoals) << ":" << (visitorPPgoals) << "\n";
    myfile << (homePPtimes) << ":" << (visitorPPtimes) << "\n";
    myfile << (homePPshots) << ":" << (visitorPPshots) << "\n";
    
    int homePPtimetotalsec;
    int homePPtimeminutes;
    int homePPtimeseconds;
    homePPtimetotalsec = (homePPtime + homePPtimemulti * 256);
    homePPtimeminutes = homePPtimetotalsec / 60;
    homePPtimeseconds = homePPtimetotalsec % 60;
    int visitorPPtimetotalsec;
    int visitorPPtimeminutes;
    int visitorPPtimeseconds;
    visitorPPtimetotalsec = (visitorPPtime + visitorPPtimemulti * 256);
    visitorPPtimeminutes = visitorPPtimetotalsec / 60;
    visitorPPtimeseconds = visitorPPtimetotalsec % 60;
    
    myfile << (homePPtimetotalsec) << ":" << (visitorPPtimetotalsec) << "\n";
    myfile << (visitorPPtimes) << ":" << (homePPtimes) << "\n";// SH times (reversed PP times)
    myfile << (visitorPPtimetotalsec) << ":" << (homePPtimetotalsec) << "\n"; // SH time (sec)
    myfile << (homePenminutes) << ":" << (visitorPenminutes) << "\n";
    int homeAzonetotalsec;
    int homeAzoneminutes;
    int homeAzoneseconds;
    homeAzonetotalsec = (homeAzonetime + homeAzonetimemulti * 256);
    homeAzoneminutes = homeAzonetotalsec / 60;
    homeAzoneseconds = homeAzonetotalsec % 60;
    int visitorAzonetotalsec;
    int visitorAzoneminutes;
    int visitorAzoneseconds;
    visitorAzonetotalsec = (visitorAzonetime + visitorAzonetimemulti * 256);
    visitorAzoneminutes = visitorAzonetotalsec / 60;
    visitorAzoneseconds = visitorAzonetotalsec % 60;
    myfile << (homeAzonetotalsec) << ":" << (visitorAzonetotalsec) << "\n" ; 
    myfile << (homeFaceoffswon) << ":" << (visitorFaceoffswon) << "\n";
    myfile << (homeOffFaceoffswon) << ":" << (visitorOffFaceoffswon) << "\n";
    myfile << (homeOnetimerpass) << ":" << (visitorOnetimerpass) << "\n";
    myfile << (homeOnetimershot) << ":" << (visitorOnetimershot) << "\n";
    myfile << (homeBodychecks) << ":" << (visitorBodychecks) << "\n";
    myfile << (homePassingattempt) << ":" << (visitorPassingattempt) << "\n";
    myfile << (homePassingsuccess) << ":" << (visitorPassingsuccess) << "\n";

// Players game stats (hometeam) 
myfile << "PLAYERS\n";
   int Goals; // Players ->
    int Assists;
    int PIM;
    int Plusminus;
    int Plusminusk;
    int PPGoals;
    int SHGoals;
    int EN;
    int Shots; // <- Players 
    int icetimesec; // Goalies ->
    int icetimemin;
    int icetimetotalsec;
    int SA;
    int GA; // <- Goalies
    int homealku;
    homealku = 2936; //Hometeam players starting address GAME.SAV 
    int matkapelaajaan = 0;
    int alkupiste = 76;
    long int keydbalku;
    string etunimi;
    string sukunimi;
    int numero = 0;
    
    int skratsi = 228;
    int skratsit[7];
    skratsi = skratsi + (hometeam * 744);
    
    int skratsit0, skratsit1, skratsit2, skratsit3, skratsit4, skratsit5, skratsit6, skratsit7;
    
    skratsit0 = fileBuf3[skratsi];
    skratsi++;
    skratsit1 = fileBuf3[skratsi];
    skratsi++;
    skratsit2 = fileBuf3[skratsi];
    skratsi++;
    skratsit3 = fileBuf3[skratsi];
    skratsi++;
    skratsit4 = fileBuf3[skratsi];
    skratsi++;
    skratsit5 = fileBuf3[skratsi];
    skratsi++;
    skratsit6 = fileBuf3[skratsi];
    skratsi++;
    skratsit7 = fileBuf3[skratsi];
    int teamdbnro = 0;
    

    
    
    for( int a=0; a < 25; a = a+1 ) // check: keydbalku < 41000
                                               // original players end at 35048, 
                                               // for new players will be reserved spots for 100 players 52*100 = 5200,
                                               // so 35048+5200 = 40248. Set ending here for > 41000.
                                               // This works if roster is not full (under 25 players), if roster is full, loop wont stop.
                                               
                                               // NOW CHANGED LIKE THIS: Loop will be go round 25 times (25 players on each team on KOHL league)
                                               
                                               // Change this depending on your rosters
                                          
   
    { 
          
         Goals = fileBuf[homealku];
         Assists = fileBuf[homealku + 2];
         PIM = fileBuf[homealku + 4];
         Plusminus = fileBuf[homealku + 6];
           if (fileBuf[homealku + 7] == 255)
           {
            Plusminus = (Plusminus - 256);                     
           }
         PPGoals = fileBuf[homealku + 8];
         SHGoals = fileBuf[homealku + 10];
         EN = fileBuf[homealku + 12];
         Shots = fileBuf[homealku + 14];
         
         
         
          // Find Names
                
                
                
                alkupiste = alkupiste + (hometeam * 744) + matkapelaajaan;
                keydbalku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //From TEAMS.DB offset to KEY.DB
                
                
                if (keydbalku > 41000) 
                {
                 // bypassing illegal player (empty spot on roster)         
                }
                else 
                {
                sukunimi = ""; 
                etunimi = "";
                
                int player;
                
                
                player = keydbalku + 1;
                numero = fileBuf2[player]; 
                
                 player = keydbalku + 3;
                 // Firstname
                       for( int a=0; fileBuf2[player+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[player+a];     
                       }
                
                player = keydbalku + 19;
                 // Lastname
                       for( int b=0; fileBuf2[player+b] != 0; b = b+1 )
                       {
                            sukunimi += fileBuf2[player + b];     
                       }
              
               // Find names ends here
               matkapelaajaan = matkapelaajaan + 4;
               alkupiste = 76;
         
               if (skratsit0 == teamdbnro){ // player sratched, no printing 
               }       
               else if (skratsit1 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit2 == teamdbnro){ // player sratched, no printing
               }  
               else if (skratsit3 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit4 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit5 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit6 == teamdbnro){ // player sratched, no printing
               }  
               else if (skratsit7 == teamdbnro){ // player sratched, no printing
               }     
               else {
               myfile << (homet) << ":" << (numero) << ":" << (etunimi) << " " << (sukunimi) << ":" << (Goals) << ":" << (Assists) << ":" << (PIM) << ":" << (Plusminus) << ":" << (PPGoals) << ":" << (SHGoals) << ":" << (EN) << ":" << (Shots) << "\n";
               }   
               teamdbnro = teamdbnro + 1;
               homealku = homealku + 16;
               }
               
    }

// Players game stats (visitorteam)
   
    int visitoralku;
    visitoralku = 3336; //Visitorteam players start in GAME.SAV
    matkapelaajaan = 0;
    alkupiste = 76;
    numero = 0;
    keydbalku = 0;
    
    skratsi = 228;
    skratsi = skratsi + (visitorteam * 744);
    
    skratsit0 = fileBuf3[skratsi];
    skratsi++;
    skratsit1 = fileBuf3[skratsi];
    skratsi++;
    skratsit2 = fileBuf3[skratsi];
    skratsi++;
    skratsit3 = fileBuf3[skratsi];
    skratsi++;
    skratsit4 = fileBuf3[skratsi];
    skratsi++;
    skratsit5 = fileBuf3[skratsi];
    skratsi++;
    skratsit6 = fileBuf3[skratsi];
    skratsi++;
    skratsit7 = fileBuf3[skratsi];
    teamdbnro = 0;
    
    for( int a=0; a < 25; a = a+1 ) 
    { 
         Goals = fileBuf[visitoralku];
         Assists = fileBuf[visitoralku + 2];
         PIM = fileBuf[visitoralku + 4];
         Plusminus = fileBuf[visitoralku + 6];
           if (fileBuf[visitoralku + 7] == 255)
           {
            Plusminus = (Plusminus - 256);                     
           }
         PPGoals = fileBuf[visitoralku + 8];
         SHGoals = fileBuf[visitoralku + 10];
         EN = fileBuf[visitoralku + 12];
         Shots = fileBuf[visitoralku + 14];
         
          // Find names
                
                
                
                alkupiste = alkupiste + (visitorteam * 744) + matkapelaajaan;
                keydbalku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offset KEY.DB
                if (keydbalku > 41000) 
                {
                // illegal player (empty spot on roster)               
                }
                else 
                {
                sukunimi = ""; 
                etunimi = "";
                int player;
                
                
                player = keydbalku + 1;
                numero = fileBuf2[player]; 
                
                player = keydbalku + 3;
                 // Firstname
                       for( int a=0; fileBuf2[player+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[player+a];     
                       }
                
                player = keydbalku + 19;
                 // Lastname
                       for( int b=0; fileBuf2[player+b] != 0; b = b+1 )
                       {
                            sukunimi += fileBuf2[player + b];     
                       }
              
               // finding names ends here
               matkapelaajaan = matkapelaajaan + 4;
               alkupiste = 76;
               
               if (skratsit0 == teamdbnro){ // player sratched, no printing
               }       
               else if (skratsit1 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit2 == teamdbnro){ // player sratched, no printing
               }  
               else if (skratsit3 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit4 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit5 == teamdbnro){ // player sratched, no printing
               } 
               else if (skratsit6 == teamdbnro){ // player sratched, no printing
               }  
               else if (skratsit7 == teamdbnro){ // player sratched, no printing
               }     
               else {
               myfile << (visit) << ":" << (numero) << ":" << (etunimi) << " " << (sukunimi) << ":" << (Goals) << ":" << (Assists) << ":" << (PIM) << ":" << (Plusminus) << ":" << (PPGoals) << ":" << (SHGoals) << ":" << (EN) << ":" << (Shots) << "\n";
               }   
               teamdbnro = teamdbnro + 1;
               visitoralku = visitoralku + 16;
               }
    }

// Goalies game stats (hometeam)
myfile << "GOALIES\n";
int homegoaliesalku; // GOALIES
    homegoaliesalku = 3736; //Hometeam goalies start GAME.SAV 
    int matkamaalivahtiin = 0;
    alkupiste = 176;
    numero = 0;
    keydbalku = 0;

  
    
    for( int a=0; a < 3; a = a+1 ) // empty goealie spot
    { 
 
         
         int icetimetotalsec = 0;
         int icetimeminutes = 0;
         int icetimeseconds = 0;
         
         icetimesec = fileBuf[homegoaliesalku];
         icetimemin = fileBuf[homegoaliesalku + 1];
         SA = fileBuf[homegoaliesalku + 2];
         GA = fileBuf[homegoaliesalku + 4];
         
         icetimetotalsec = (icetimesec + icetimemin * 256);
         icetimeminutes = icetimetotalsec / 60;
         icetimeseconds = icetimetotalsec % 60;
         
         if ( icetimetotalsec > 0)
         {
          // find names
            
                alkupiste = alkupiste + (hometeam * 744) + matkamaalivahtiin;
                keydbalku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); //offsetti KEY.DB:hen
                if (keydbalku > 41000) // empty goalie spot
                {
                //Illegal player           
                }
                else 
                {
                sukunimi = ""; 
                etunimi = "";
                
                int goalie;
              
                goalie = keydbalku + 1;
                numero = fileBuf2[goalie]; 
                
                goalie = keydbalku + 3;
                 // Firstsname
                       for( int a=0; fileBuf2[goalie+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[goalie+a];     
                       }
                
                goalie = keydbalku + 19;
                 // Lastname
                       for( int b=0; fileBuf2[goalie+b] != 0; b = b+1 )
                       {
                            sukunimi += fileBuf2[goalie + b];     
                       }
                 } //else ends here
               // find names ends here
               
               myfile << (homet) << ":" << (numero) << ":" << (etunimi) << " " << (sukunimi) << ": " << (SA) << ":" << (GA) << ":" << (icetimetotalsec) << "\n";
               
          } // if ends here
                
          matkamaalivahtiin = matkamaalivahtiin + 4; //move to current goalie spot in TEAMS.DB
          alkupiste = 176;
         
         
         homegoaliesalku = homegoaliesalku + 6;
              
               
    } 

// Goalies game stats (visitorteam)

int visitorgoaliesalku; 
    visitorgoaliesalku = 3754; 
    matkamaalivahtiin = 0;
    alkupiste = 176;
    numero = 0;
    keydbalku = 0;

  
    
    for( int a=0; a < 3; a = a+1 ) 
    { 
 
         
         int icetimetotalsec = 0;
         int icetimeminutes = 0;
         int icetimeseconds = 0;
         
         icetimesec = fileBuf[visitorgoaliesalku];
         icetimemin = fileBuf[visitorgoaliesalku + 1];
         SA = fileBuf[visitorgoaliesalku + 2];
         GA = fileBuf[visitorgoaliesalku + 4];
         
         icetimetotalsec = (icetimesec + icetimemin * 256);
         icetimeminutes = icetimetotalsec / 60;
         icetimeseconds = icetimetotalsec % 60;
         
         if ( icetimetotalsec > 0)
         {
          // find names
            
                alkupiste = alkupiste + (visitorteam * 744) + matkamaalivahtiin;
                keydbalku = (256 * fileBuf3[alkupiste+1] + fileBuf3[alkupiste]); 
                if (keydbalku > 41000) 
                {
                //Illegal goalie             
                }
                else 
                {
                sukunimi = ""; 
                etunimi = "";
                
                int goalie;
              
                goalie = keydbalku + 1;
                numero = fileBuf2[goalie]; 
                
                goalie = keydbalku + 3;
                 // Firstname
                       for( int a=0; fileBuf2[goalie+a] != 0; a = a+1 )
                       {
                            etunimi += fileBuf2[goalie+a];     
                       }
                
                goalie = keydbalku + 19;
                 // Lastname
                       for( int b=0; fileBuf2[goalie+b] != 0; b = b+1 )
                       {
                            sukunimi += fileBuf2[goalie + b];     
                       }
                 } //else end here
               // Find names ends here
               myfile << (visit) << ":" << (numero) << ":" << (etunimi) << " " << (sukunimi) << ": " << (SA) << ":" << (GA) << ":" << (icetimetotalsec) << "\n";
               
             
          } // if pttyy
                
          matkamaalivahtiin = matkamaalivahtiin + 4; 
          alkupiste = 176;
         
         
         visitorgoaliesalku = visitorgoaliesalku + 6;
              
               
    } 
myfile << "END\n";
// Call Gsummary
gsummary ();


// Closing files and buffers 
  
  myfile.close();
  delete[]fileBuf;
  delete[]fileBuf2;
  delete[]fileBuf3;
  delete[]fileBuf4;
  
  //cin.get();
  
  fclose(file);
  fclose(file2);
  fclose(file3);
  fclose(file4);
  
   return 0;
}



